/*
-----------------------------------------------------
StatsStructGen.py 1.2

This file was autogenerated with run cmd:
  "gen_scripts/StatsStructGen.py --packagename=org.frc836.database --classname=PitStats --tablename=scout_pit_data_2025 --infile=FRC_Scouting_Server/scouting.sql --outfile=app/src/main/java/org/frc836/database/PitStats.java --gameinfocol=auto_barge_zone_id --gameinfocol=auto_first_face_id --gameinfocol=auto_ground_face_id --gameinfocol=auto_feeder_station_id"

python version info:
  3.13.1 (main, Dec  4 2024, 18:05:56) [GCC 14.2.1 20240910]

Please take heed of modifying unnecessarily
-----------------------------------------------------
*/

package org.frc836.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import org.frc836.database.FRCScoutingContract.SCOUT_PIT_DATA_2025_Entry;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.Date;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public class PitStats {


    public String event_id;
    public int team_id;
    public int pass_number;
    public double robot_inspection_weight_lbs;
    public double robot_wheel_width_in;
    public String drive_id;
    public String robot_cg_id;
    public boolean can_score_proc;
    public boolean can_reef_intake_algae;
    public boolean can_ground_intake_algae;
    public boolean can_ground_intake_coral;
    public boolean can_station_intake_coral;
    public boolean can_remove_algae_l2;
    public boolean can_remove_algae_l3;
    public boolean can_carry_both_simul;
    public boolean can_score_on_intake_side;
    public boolean can_score_opp_intake_side;
    public boolean can_score_perp_intake_side;
    public boolean has_coral_tunnel;
    public boolean can_manip_coral_angle;
    public boolean can_extend_arm_in_motion;
    public double coral_scoring_side_width_in;
    public double coral_intake_side_width_in;
    public String notes;
    

    public static final String TABLE_NAME = SCOUT_PIT_DATA_2025_Entry.TABLE_NAME;
    public static final String COLUMN_NAME_ID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_ID;
    public static final String COLUMN_NAME_EVENT_ID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_EVENT_ID;
    public static final String COLUMN_NAME_TEAM_ID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_TEAM_ID;
    public static final String COLUMN_NAME_PASS_NUMBER = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_PASS_NUMBER;
    public static final String COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS;
    public static final String COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN;
    public static final String COLUMN_NAME_DRIVE_ID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_DRIVE_ID;
    public static final String COLUMN_NAME_ROBOT_CG_ID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_ROBOT_CG_ID;
    public static final String COLUMN_NAME_CAN_SCORE_PROC = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_SCORE_PROC;
    public static final String COLUMN_NAME_CAN_REEF_INTAKE_ALGAE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_REEF_INTAKE_ALGAE;
    public static final String COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE;
    public static final String COLUMN_NAME_CAN_GROUND_INTAKE_CORAL = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_GROUND_INTAKE_CORAL;
    public static final String COLUMN_NAME_CAN_STATION_INTAKE_CORAL = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_STATION_INTAKE_CORAL;
    public static final String COLUMN_NAME_CAN_REMOVE_ALGAE_L2 = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_REMOVE_ALGAE_L2;
    public static final String COLUMN_NAME_CAN_REMOVE_ALGAE_L3 = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_REMOVE_ALGAE_L3;
    public static final String COLUMN_NAME_CAN_CARRY_BOTH_SIMUL = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_CARRY_BOTH_SIMUL;
    public static final String COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE;
    public static final String COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE;
    public static final String COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE;
    public static final String COLUMN_NAME_HAS_CORAL_TUNNEL = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_HAS_CORAL_TUNNEL;
    public static final String COLUMN_NAME_CAN_MANIP_CORAL_ANGLE = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_MANIP_CORAL_ANGLE;
    public static final String COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION;
    public static final String COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN;
    public static final String COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN;
    public static final String COLUMN_NAME_NOTES = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_NOTES;
    public static final String COLUMN_NAME_INVALID = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_INVALID;
    public static final String COLUMN_NAME_TIMESTAMP = SCOUT_PIT_DATA_2025_Entry.COLUMN_NAME_TIMESTAMP;
    

    public PitStats() {
        init();
    }
    
    public void init() {
        event_id = "";
        team_id = 0;
        pass_number = 0;
        robot_inspection_weight_lbs = 0;
        robot_wheel_width_in = 0;
        drive_id = "Other";
        robot_cg_id = "Unknown";
        can_score_proc = false;
        can_reef_intake_algae = false;
        can_ground_intake_algae = false;
        can_ground_intake_coral = false;
        can_station_intake_coral = false;
        can_remove_algae_l2 = false;
        can_remove_algae_l3 = false;
        can_carry_both_simul = false;
        can_score_on_intake_side = false;
        can_score_opp_intake_side = false;
        can_score_perp_intake_side = false;
        has_coral_tunnel = false;
        can_manip_coral_angle = false;
        can_extend_arm_in_motion = false;
        coral_scoring_side_width_in = 0;
        coral_intake_side_width_in = 0;
        notes = "";
    }
    

    public void copyFrom(PitStats other) {
        this.event_id = other.event_id;
        this.team_id = other.team_id;
        this.pass_number = other.pass_number;
        this.robot_inspection_weight_lbs = other.robot_inspection_weight_lbs;
        this.robot_wheel_width_in = other.robot_wheel_width_in;
        this.drive_id = other.drive_id;
        this.robot_cg_id = other.robot_cg_id;
        this.can_score_proc = other.can_score_proc;
        this.can_reef_intake_algae = other.can_reef_intake_algae;
        this.can_ground_intake_algae = other.can_ground_intake_algae;
        this.can_ground_intake_coral = other.can_ground_intake_coral;
        this.can_station_intake_coral = other.can_station_intake_coral;
        this.can_remove_algae_l2 = other.can_remove_algae_l2;
        this.can_remove_algae_l3 = other.can_remove_algae_l3;
        this.can_carry_both_simul = other.can_carry_both_simul;
        this.can_score_on_intake_side = other.can_score_on_intake_side;
        this.can_score_opp_intake_side = other.can_score_opp_intake_side;
        this.can_score_perp_intake_side = other.can_score_perp_intake_side;
        this.has_coral_tunnel = other.has_coral_tunnel;
        this.can_manip_coral_angle = other.can_manip_coral_angle;
        this.can_extend_arm_in_motion = other.can_extend_arm_in_motion;
        this.coral_scoring_side_width_in = other.coral_scoring_side_width_in;
        this.coral_intake_side_width_in = other.coral_intake_side_width_in;
        this.notes = other.notes;
    
    }

    public ContentValues getValues(SQLiteDatabase database) {
        ContentValues vals = new ContentValues();
        long ev = DB.getEventIdFromName(event_id, database);
        vals.put(COLUMN_NAME_ID, ev * 10000000 + (long)pass_number * 10000 + team_id);
        vals.put(COLUMN_NAME_EVENT_ID, ev);
        vals.put(COLUMN_NAME_TEAM_ID, team_id);
        vals.put(COLUMN_NAME_PASS_NUMBER, pass_number);
        vals.put(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS, robot_inspection_weight_lbs);
        vals.put(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN, robot_wheel_width_in);
        vals.put(COLUMN_NAME_DRIVE_ID, DB.getDriveIdFromName(drive_id, database));
        vals.put(COLUMN_NAME_ROBOT_CG_ID, DB.getCgIdFromName(robot_cg_id, database));
        vals.put(COLUMN_NAME_CAN_SCORE_PROC, can_score_proc ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE, can_reef_intake_algae ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE, can_ground_intake_algae ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL, can_ground_intake_coral ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_STATION_INTAKE_CORAL, can_station_intake_coral ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_REMOVE_ALGAE_L2, can_remove_algae_l2 ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_REMOVE_ALGAE_L3, can_remove_algae_l3 ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL, can_carry_both_simul ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE, can_score_on_intake_side ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE, can_score_opp_intake_side ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE, can_score_perp_intake_side ? 1 : 0);
        vals.put(COLUMN_NAME_HAS_CORAL_TUNNEL, has_coral_tunnel ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE, can_manip_coral_angle ? 1 : 0);
        vals.put(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION, can_extend_arm_in_motion ? 1 : 0);
        vals.put(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN, coral_scoring_side_width_in);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN, coral_intake_side_width_in);
        vals.put(COLUMN_NAME_NOTES, notes);
        vals.put(COLUMN_NAME_INVALID, 1);
    
        return vals;
    }

    public void fromCursor(Cursor c, DB db, SQLiteDatabase database) {
        fromCursor(c, db, database, 0);
    }
    
    public void fromCursor(Cursor c, DB db, SQLiteDatabase database, int pos) {
        c.moveToPosition(pos);
        event_id = DB.getEventNameFromId(c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_EVENT_ID)), database);
        team_id = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_TEAM_ID));
        pass_number = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_PASS_NUMBER));
        robot_inspection_weight_lbs = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS));
        robot_wheel_width_in = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN));
        drive_id = DB.getDriveNameFromId(c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_DRIVE_ID)), database);
        robot_cg_id = DB.getCgNameFromId(c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_ROBOT_CG_ID)), database);
        can_score_proc = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_SCORE_PROC)) != 0;
        can_reef_intake_algae = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE)) != 0;
        can_ground_intake_algae = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE)) != 0;
        can_ground_intake_coral = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL)) != 0;
        can_station_intake_coral = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_STATION_INTAKE_CORAL)) != 0;
        can_remove_algae_l2 = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_REMOVE_ALGAE_L2)) != 0;
        can_remove_algae_l3 = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_REMOVE_ALGAE_L3)) != 0;
        can_carry_both_simul = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL)) != 0;
        can_score_on_intake_side = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE)) != 0;
        can_score_opp_intake_side = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE)) != 0;
        can_score_perp_intake_side = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE)) != 0;
        has_coral_tunnel = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_HAS_CORAL_TUNNEL)) != 0;
        can_manip_coral_angle = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE)) != 0;
        can_extend_arm_in_motion = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION)) != 0;
        coral_scoring_side_width_in = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN));
        coral_intake_side_width_in = c.getInt(c.getColumnIndexOrThrow(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN));
        notes = c.getString(c.getColumnIndexOrThrow(COLUMN_NAME_NOTES));
    }

    public static String[] getProjection() {
        List<String> temp = new ArrayList<String>(24);
        temp.add(COLUMN_NAME_EVENT_ID);
        temp.add(COLUMN_NAME_TEAM_ID);
        temp.add(COLUMN_NAME_PASS_NUMBER);
        temp.add(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS);
        temp.add(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN);
        temp.add(COLUMN_NAME_DRIVE_ID);
        temp.add(COLUMN_NAME_ROBOT_CG_ID);
        temp.add(COLUMN_NAME_CAN_SCORE_PROC);
        temp.add(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE);
        temp.add(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE);
        temp.add(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL);
        temp.add(COLUMN_NAME_CAN_STATION_INTAKE_CORAL);
        temp.add(COLUMN_NAME_CAN_REMOVE_ALGAE_L2);
        temp.add(COLUMN_NAME_CAN_REMOVE_ALGAE_L3);
        temp.add(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL);
        temp.add(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE);
        temp.add(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE);
        temp.add(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE);
        temp.add(COLUMN_NAME_HAS_CORAL_TUNNEL);
        temp.add(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE);
        temp.add(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION);
        temp.add(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN);
        temp.add(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN);
        temp.add(COLUMN_NAME_NOTES);
        String[] projection = new String[temp.size()];
        return temp.toArray(projection);
    }

    public static boolean isTextField(String column_name) {
        if (COLUMN_NAME_NOTES.equalsIgnoreCase(column_name)) return true;
    
        return false;
    }

    public static boolean isGameInfoLookup(String column_name) {
        return false;
    }

    public static ContentValues jsonToCV(JSONObject json) throws JSONException {
        ContentValues vals = new ContentValues();
        vals.put(COLUMN_NAME_ID, json.has(COLUMN_NAME_ID) ? json.getInt(COLUMN_NAME_ID) : 0);
        vals.put(COLUMN_NAME_EVENT_ID, json.has(COLUMN_NAME_EVENT_ID) ? json.getInt(COLUMN_NAME_EVENT_ID) : 0);
        vals.put(COLUMN_NAME_TEAM_ID, json.has(COLUMN_NAME_TEAM_ID) ? json.getInt(COLUMN_NAME_TEAM_ID) : 0);
        vals.put(COLUMN_NAME_PASS_NUMBER, json.has(COLUMN_NAME_PASS_NUMBER) ? json.getInt(COLUMN_NAME_PASS_NUMBER) : 0);
        vals.put(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS, json.has(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS) ? json.getInt(COLUMN_NAME_ROBOT_INSPECTION_WEIGHT_LBS) : 0);
        vals.put(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN, json.has(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN) ? json.getInt(COLUMN_NAME_ROBOT_WHEEL_WIDTH_IN) : 0);
        vals.put(COLUMN_NAME_DRIVE_ID, json.has(COLUMN_NAME_DRIVE_ID) ? json.getInt(COLUMN_NAME_DRIVE_ID) : 0);
        vals.put(COLUMN_NAME_ROBOT_CG_ID, json.has(COLUMN_NAME_ROBOT_CG_ID) ? json.getInt(COLUMN_NAME_ROBOT_CG_ID) : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_PROC, json.has(COLUMN_NAME_CAN_SCORE_PROC) ? json.getInt(COLUMN_NAME_CAN_SCORE_PROC) : 0);
        vals.put(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE, json.has(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE) ? json.getInt(COLUMN_NAME_CAN_REEF_INTAKE_ALGAE) : 0);
        vals.put(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE, json.has(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE) ? json.getInt(COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE) : 0);
        vals.put(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL, json.has(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL) ? json.getInt(COLUMN_NAME_CAN_GROUND_INTAKE_CORAL) : 0);
        vals.put(COLUMN_NAME_CAN_STATION_INTAKE_CORAL, json.has(COLUMN_NAME_CAN_STATION_INTAKE_CORAL) ? json.getInt(COLUMN_NAME_CAN_STATION_INTAKE_CORAL) : 0);
        vals.put(COLUMN_NAME_CAN_REMOVE_ALGAE_L2, json.has(COLUMN_NAME_CAN_REMOVE_ALGAE_L2) ? json.getInt(COLUMN_NAME_CAN_REMOVE_ALGAE_L2) : 0);
        vals.put(COLUMN_NAME_CAN_REMOVE_ALGAE_L3, json.has(COLUMN_NAME_CAN_REMOVE_ALGAE_L3) ? json.getInt(COLUMN_NAME_CAN_REMOVE_ALGAE_L3) : 0);
        vals.put(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL, json.has(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL) ? json.getInt(COLUMN_NAME_CAN_CARRY_BOTH_SIMUL) : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE, json.has(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE) ? json.getInt(COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE) : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE, json.has(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE) ? json.getInt(COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE) : 0);
        vals.put(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE, json.has(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE) ? json.getInt(COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE) : 0);
        vals.put(COLUMN_NAME_HAS_CORAL_TUNNEL, json.has(COLUMN_NAME_HAS_CORAL_TUNNEL) ? json.getInt(COLUMN_NAME_HAS_CORAL_TUNNEL) : 0);
        vals.put(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE, json.has(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE) ? json.getInt(COLUMN_NAME_CAN_MANIP_CORAL_ANGLE) : 0);
        vals.put(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION, json.has(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION) ? json.getInt(COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION) : 0);
        vals.put(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN, json.has(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN) ? json.getInt(COLUMN_NAME_CORAL_SCORING_SIDE_WIDTH_IN) : 0);
        vals.put(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN, json.has(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN) ? json.getInt(COLUMN_NAME_CORAL_INTAKE_SIDE_WIDTH_IN) : 0);
        vals.put(COLUMN_NAME_NOTES, json.has(COLUMN_NAME_NOTES) ? json.getString(COLUMN_NAME_NOTES) : "");
        vals.put(COLUMN_NAME_INVALID, 0);
        vals.put(COLUMN_NAME_TIMESTAMP, DB.dateParser.format(new Date(json.getLong(COLUMN_NAME_TIMESTAMP) * 1000)));
        return vals;
    }

    public LinkedHashMap<String,String> getDisplayData() {
        LinkedHashMap<String,String> vals = new LinkedHashMap<String,String>();
        vals.put( COLUMN_NAME_EVENT_ID, event_id);
        vals.put( COLUMN_NAME_TEAM_ID, String.valueOf(team_id));
        vals.put( COLUMN_NAME_PASS_NUMBER, String.valueOf(pass_number));
        vals.put( COLUMN_NAME_DRIVE_ID, drive_id);
        vals.put( COLUMN_NAME_ROBOT_CG_ID, robot_cg_id);
        vals.put( COLUMN_NAME_CAN_SCORE_PROC, String.valueOf(can_score_proc ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_REEF_INTAKE_ALGAE, String.valueOf(can_reef_intake_algae ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_GROUND_INTAKE_ALGAE, String.valueOf(can_ground_intake_algae ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_GROUND_INTAKE_CORAL, String.valueOf(can_ground_intake_coral ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_STATION_INTAKE_CORAL, String.valueOf(can_station_intake_coral ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_REMOVE_ALGAE_L2, String.valueOf(can_remove_algae_l2 ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_REMOVE_ALGAE_L3, String.valueOf(can_remove_algae_l3 ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_CARRY_BOTH_SIMUL, String.valueOf(can_carry_both_simul ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_SCORE_ON_INTAKE_SIDE, String.valueOf(can_score_on_intake_side ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_SCORE_OPP_INTAKE_SIDE, String.valueOf(can_score_opp_intake_side ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_SCORE_PERP_INTAKE_SIDE, String.valueOf(can_score_perp_intake_side ? 1 : 0));
        vals.put( COLUMN_NAME_HAS_CORAL_TUNNEL, String.valueOf(has_coral_tunnel ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_MANIP_CORAL_ANGLE, String.valueOf(can_manip_coral_angle ? 1 : 0));
        vals.put( COLUMN_NAME_CAN_EXTEND_ARM_IN_MOTION, String.valueOf(can_extend_arm_in_motion ? 1 : 0));
        vals.put( COLUMN_NAME_NOTES, notes);
        return vals;
    }

}